import {Game} from "./game.js"
import * as util from "./util.js"
import {IllegalAction} from "./server/illegalAction.js"
class RoomManager {
  games:Game[];
  constructor(){
    this.games = [];
  }
  getGameByID(id:string) {
    const game = this.games.filter(obj => obj.id == id)[0]
    return game
  }

  addGame(id:string, options:any) {
    const game = new Game(id, options);
    this.games.push(game);
    return game
  }
  removeGameByID(id:string) {
    this.games = this.games.filter(obj => obj.id != id);

  }

  getAllPlayerIDs() {
    let ids = []
    for (let i = 0; i < this.games.length; i++) {
      for (let j = 0; j < this.games[i].players.length; j++) {
        ids.push(this.games[i].players[j].id)
      }
    }
    return ids
  }

  getAllGameIDs() {
    let ids = []
    for (let i = 0; i < this.games.length; i++) {
      ids.push(this.games[i].id)
    }
    return ids
  }

  playerJoinGame(roomCode:string, playerName:string, playerColor:number, playerID:string):any[] {
    // See if the client is already in a game
    if (this.getAllPlayerIDs().includes(playerID)) {
    }
    if (!this.getAllGameIDs().includes(roomCode)) {
    }
    const game = this.getGameByID(roomCode);
    const player = game.addPlayer(playerID, playerName, playerColor);
    // See if player name is taken already
    // if (player === false) {
    //   this.removeGameByID(game.id)
    // }
    return [game, player]
  }

  playerCreateGame(options:any, playerName:string, playerColor:number, playerID:string):any[] {
    if (this.getAllPlayerIDs().includes(playerID)) {
      // return new IllegalAction(playerID, 22)
    }
    const id = util.createCode()
    const game = this.addGame(id, options)
    const player = game.addPlayer(playerID, playerName, playerColor);
    return [game, player]

  }

}


export var roomManager = new RoomManager();
